--#####################################################################
-- component Analog_sys_assc_wrapper
-- port ( 
--     CLK:in std_logic;
--     NRESET:in std_logic;
--     INIT_ADDR:in std_logic_vector(8 downto 0);
--     INIT_ASSC_WR:in std_logic;
--     INIT_DI:in std_logic_vector(8 downto 0);
--     INIT_DONE:in std_logic;
--     USER_ASSC_ADDR:in std_logic_vector(8 downto 0);
--     USER_ASSC_RD:in std_logic;
--     USER_ASSC_RAM_BUSY:out std_logic;
--     EV_ASSC_ADDR:in std_logic_vector(8 downto 0);
--     EV_ASSC_RD:in std_logic;
--     EV_EVFLAG:in std_logic;
--     EV_DONE:in std_logic;
--     TR_TRFLAG:in std_logic;
--     TR_DONE:in std_logic;
--     ASSC_RAM_WR_BUSY_B:out std_logic;
--     ASSC_RAM_ADDR_A:out std_logic_vector(8 downto 0);
--     ASSC_RAM_RW_A:out std_logic;
--     ASSC_RAM_CSN_A:out std_logic;
--     ASSC_RAM_DI_A:out std_logic_vector(8 downto 0);
--     ASSC_RAM_ADDR_B:out std_logic_vector(8 downto 0);
--     ASSC_RAM_RW_B:out std_logic;
--     ASSC_RAM_CSN_B:out std_logic;
--     ASSC_RAM_DI_B:out std_logic_vector(8 downto 0);
--     ASSC_RAM_DO_B:in std_logic_vector(8 downto 0);
--     ASSC_XMODE:in std_logic;
--     ASSC_XTRIG:in std_logic;
--     ASSC_SEQJUMP:in std_logic;
--     ASSC_SEQIN:in std_logic_vector(6-1 downto 0);
--     ASSC_SEQOUT:out std_logic_vector(6-1 downto 0);
--     ASSC_SEQCHANGE:out std_logic;
--     ASSC_DONE:out std_logic;
--     ASSC_WAIT:out std_logic;
--     ASSC_SAMPFLAG:out std_logic;
--     ASSC_CHSAT:out std_logic;
--     ASSC_CHLATD:out std_logic;
--     ADC_CALIBRATE:in std_logic;
--     ADC_BUSY:in std_logic;
--     ADC_RESULT:in std_logic_vector(11 downto 0);
--     ADC_START:out std_logic;
--     ADC_PDOWN:out std_logic;
--     ADC_RESET:out std_logic;
--     ADC_MODE:out std_logic_vector(3 downto 0);
--     ADC_VREFSEL:out std_logic;
--     ADC_CHNR:out std_logic_vector(4 downto 0);
--     ADC_STC:out std_logic_vector(7 downto 0);
--     ADC_DVC:out std_logic_vector(7 downto 0);
--     CM_STB:out std_logic_vector(9 downto 0);
--     TM_STB:out std_logic_vector(10 downto 0)
--      );
-- end component;

--U0:Analog_sys_assc_wrapper
--port map(
--         CLK=>  ;
--         NRESET=>  ;
--         INIT_ADDR=>  ;
--         INIT_ASSC_WR=>  ;
--         INIT_DI=>  ;
--         INIT_DONE=>  ;
--         USER_ASSC_ADDR=>  ;
--         USER_ASSC_RD=>  ;
--         USER_ASSC_RAM_BUSY=>  ;
--         EV_ASSC_ADDR=>  ;
--         EV_ASSC_RD=>  ;
--         EV_EVFLAG=>  ;
--         EV_DONE=>  ;
--         TR_TRFLAG=>  ;
--         TR_DONE=>  ;
--         ASSC_RAM_WR_BUSY_B=>  ;
--         ASSC_RAM_ADDR_A=>  ;
--         ASSC_RAM_RW_A=>  ;
--         ASSC_RAM_CSN_A=>  ;
--         ASSC_RAM_DI_A=>  ;
--         ASSC_RAM_ADDR_B=>  ;
--         ASSC_RAM_RW_B=>  ;
--         ASSC_RAM_CSN_B=>  ;
--         ASSC_RAM_DI_B=>  ;
--         ASSC_RAM_DO_B=>  ;
--         ASSC_XMODE=>  ;
--         ASSC_XTRIG=>  ;
--         ASSC_SEQJUMP=>  ;
--         ASSC_SEQIN=>  ;
--         ASSC_SEQOUT=>  ;
--         ASSC_SEQCHANGE=>  ;
--         ASSC_DONE=>  ;
--         ASSC_WAIT=>  ;
--         ASSC_SAMPFLAG=>  ;
--         ASSC_CHSAT=>  ;
--         ASSC_CHLATD=>  ;
--         ADC_CALIBRATE=>  ;
--         ADC_BUSY=>  ;
--         ADC_RESULT=>  ;
--         ADC_START=>  ;
--         ADC_PDOWN=>  ;
--         ADC_RESET=>  ;
--         ADC_MODE=>  ;
--         ADC_VREFSEL=>  ;
--         ADC_CHNR=>  ;
--         ADC_STC=>  ;
--         ADC_DVC=>  ;
--         CM_STB=>  ;
--         TM_STB=>  
--        );
--#####################################################################


library IEEE ;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity Analog_sys_assc_wrapper is  
port ( 
     CLK:in std_logic;
     NRESET:in std_logic;
     INIT_ADDR:in std_logic_vector(8 downto 0);
     INIT_ASSC_WR:in std_logic;
     INIT_DI:in std_logic_vector(8 downto 0);
     INIT_DONE:in std_logic;
     USER_ASSC_ADDR:in std_logic_vector(8 downto 0);
     USER_ASSC_RD:in std_logic;
     USER_ASSC_RAM_BUSY:out std_logic;
     EV_ASSC_ADDR:in std_logic_vector(8 downto 0);
     EV_ASSC_RD:in std_logic;
     EV_EVFLAG:in std_logic;
     EV_DONE:in std_logic;
     TR_TRFLAG:in std_logic;
     TR_DONE:in std_logic;
     ASSC_RAM_WR_BUSY_B:out std_logic;
     ASSC_RAM_ADDR_A:out std_logic_vector(8 downto 0);
     ASSC_RAM_RW_A:out std_logic;
     ASSC_RAM_CSN_A:out std_logic;
     ASSC_RAM_DI_A:out std_logic_vector(8 downto 0);
     ASSC_RAM_ADDR_B:out std_logic_vector(8 downto 0);
     ASSC_RAM_RW_B:out std_logic;
     ASSC_RAM_CSN_B:out std_logic;
     ASSC_RAM_DI_B:out std_logic_vector(8 downto 0);
     ASSC_RAM_DO_B:in std_logic_vector(8 downto 0);
     ASSC_XMODE:in std_logic;
     ASSC_XTRIG:in std_logic;
     ASSC_SEQJUMP:in std_logic;
     ASSC_SEQIN:in std_logic_vector(6-1 downto 0);
     ASSC_SEQOUT:out std_logic_vector(6-1 downto 0);
     ASSC_SEQCHANGE:out std_logic;
     ASSC_DONE:out std_logic;
     ASSC_WAIT:out std_logic;
     ASSC_SAMPFLAG:out std_logic;
     ASSC_CHSAT:out std_logic;
     ASSC_CHLATD:out std_logic;
     ADC_CALIBRATE:in std_logic;
     ADC_BUSY:in std_logic;
     ADC_RESULT:in std_logic_vector(11 downto 0);
     ADC_START:out std_logic;
     ADC_PDOWN:out std_logic;
     ADC_RESET:out std_logic;
     ADC_MODE:out std_logic_vector(3 downto 0);
     ADC_VREFSEL:out std_logic;
     ADC_CHNR:out std_logic_vector(4 downto 0);
     ADC_STC:out std_logic_vector(7 downto 0);
     ADC_DVC:out std_logic_vector(7 downto 0);
     CM_STB:out std_logic_vector(9 downto 0);
     TM_STB:out std_logic_vector(10 downto 0)
     );
end Analog_sys_assc_wrapper;

architecture DEF_ARCH of Analog_sys_assc_wrapper is

component ASSC

generic(
     TS_WIDTH:integer;
     TS_RST_VALUE:integer;
     DLYCNT_WIDTH:integer;
     ALLOW_USER_ASSC:integer;
     ALLOW_RPT:integer;
     FIXED_MODE:integer;
     FIXED_MODE_CONST:integer;
     FIXED_VREFSEL_CONST:integer;
     FIXED_STC:integer;
     FIXED_STC_CONST:integer;
     FIXED_TVC:integer;
     FIXED_TVC_CONST:integer;
     ALLOW_CM_STB_BITS:integer;
     ALLOW_TM_STB_BITS:integer
        );
port(
     CLK:in std_logic;
     NRESET:in std_logic;
     INIT_ADDR:in std_logic_vector(8 downto 0);
     INIT_ASSC_WR:in std_logic;
     INIT_DI:in std_logic_vector(8 downto 0);
     INIT_DONE:in std_logic;
     USER_ASSC_ADDR:in std_logic_vector(8 downto 0);
     USER_ASSC_RD:in std_logic;
     USER_ASSC_RAM_BUSY:out std_logic;
     EV_ASSC_ADDR:in std_logic_vector(8 downto 0);
     EV_ASSC_RD:in std_logic;
     EV_EVFLAG:in std_logic;
     EV_DONE:in std_logic;
     TR_TRFLAG:in std_logic;
     TR_DONE:in std_logic;
     ASSC_RAM_WR_BUSY_B:out std_logic;
     ASSC_RAM_ADDR_A:out std_logic_vector(8 downto 0);
     ASSC_RAM_RW_A:out std_logic;
     ASSC_RAM_CSN_A:out std_logic;
     ASSC_RAM_DI_A:out std_logic_vector(8 downto 0);
     ASSC_RAM_ADDR_B:out std_logic_vector(8 downto 0);
     ASSC_RAM_RW_B:out std_logic;
     ASSC_RAM_CSN_B:out std_logic;
     ASSC_RAM_DI_B:out std_logic_vector(8 downto 0);
     ASSC_RAM_DO_B:in std_logic_vector(8 downto 0);
     ASSC_XMODE:in std_logic;
     ASSC_XTRIG:in std_logic;
     ASSC_SEQJUMP:in std_logic;
     ASSC_SEQIN:in std_logic_vector(TS_WIDTH-1 downto 0);
     ASSC_SEQOUT:out std_logic_vector(TS_WIDTH-1 downto 0);
     ASSC_SEQCHANGE:out std_logic;
     ASSC_DONE:out std_logic;
     ASSC_WAIT:out std_logic;
     ASSC_SAMPFLAG:out std_logic;
     ASSC_CHSAT:out std_logic;
     ASSC_CHLATD:out std_logic;
     ADC_CALIBRATE:in std_logic;
     ADC_BUSY:in std_logic;
     ADC_RESULT:in std_logic_vector(11 downto 0);
     ADC_START:out std_logic;
     ADC_PDOWN:out std_logic;
     ADC_RESET:out std_logic;
     ADC_MODE:out std_logic_vector(3 downto 0);
     ADC_VREFSEL:out std_logic;
     ADC_CHNR:out std_logic_vector(4 downto 0);
     ADC_STC:out std_logic_vector(7 downto 0);
     ADC_DVC:out std_logic_vector(7 downto 0);
     CM_STB:out std_logic_vector(9 downto 0);
     TM_STB:out std_logic_vector(10 downto 0)
     );
end component;

begin

U0:ASSC
generic map(
             TS_WIDTH=>6,
             TS_RST_VALUE=>0,
             DLYCNT_WIDTH=>8,
             ALLOW_USER_ASSC=>0,
             ALLOW_RPT=>0,
             FIXED_MODE=>0,
             FIXED_MODE_CONST=>0000000000000000,
             FIXED_VREFSEL_CONST=>0,
             FIXED_STC=>0,
             FIXED_STC_CONST=>0000000000000000,
             FIXED_TVC=>0,
             FIXED_TVC_CONST=>0000000000000000,
             ALLOW_CM_STB_BITS=>0,
             ALLOW_TM_STB_BITS=>1024
           )

port map(
         CLK=>CLK,
         NRESET=>NRESET,
         INIT_ADDR=>INIT_ADDR,
         INIT_ASSC_WR=>INIT_ASSC_WR,
         INIT_DI=>INIT_DI,
         INIT_DONE=>INIT_DONE,
         USER_ASSC_ADDR=>USER_ASSC_ADDR,
         USER_ASSC_RD=>USER_ASSC_RD,
         USER_ASSC_RAM_BUSY=>USER_ASSC_RAM_BUSY,
         EV_ASSC_ADDR=>EV_ASSC_ADDR,
         EV_ASSC_RD=>EV_ASSC_RD,
         EV_EVFLAG=>EV_EVFLAG,
         EV_DONE=>EV_DONE,
         TR_TRFLAG=>TR_TRFLAG,
         TR_DONE=>TR_DONE,
         ASSC_RAM_WR_BUSY_B=>ASSC_RAM_WR_BUSY_B,
         ASSC_RAM_ADDR_A=>ASSC_RAM_ADDR_A,
         ASSC_RAM_RW_A=>ASSC_RAM_RW_A,
         ASSC_RAM_CSN_A=>ASSC_RAM_CSN_A,
         ASSC_RAM_DI_A=>ASSC_RAM_DI_A,
         ASSC_RAM_ADDR_B=>ASSC_RAM_ADDR_B,
         ASSC_RAM_RW_B=>ASSC_RAM_RW_B,
         ASSC_RAM_CSN_B=>ASSC_RAM_CSN_B,
         ASSC_RAM_DI_B=>ASSC_RAM_DI_B,
         ASSC_RAM_DO_B=>ASSC_RAM_DO_B,
         ASSC_XMODE=>ASSC_XMODE,
         ASSC_XTRIG=>ASSC_XTRIG,
         ASSC_SEQJUMP=>ASSC_SEQJUMP,
         ASSC_SEQIN=>ASSC_SEQIN,
         ASSC_SEQOUT=>ASSC_SEQOUT,
         ASSC_SEQCHANGE=>ASSC_SEQCHANGE,
         ASSC_DONE=>ASSC_DONE,
         ASSC_WAIT=>ASSC_WAIT,
         ASSC_SAMPFLAG=>ASSC_SAMPFLAG,
         ASSC_CHSAT=>ASSC_CHSAT,
         ASSC_CHLATD=>ASSC_CHLATD,
         ADC_CALIBRATE=>ADC_CALIBRATE,
         ADC_BUSY=>ADC_BUSY,
         ADC_RESULT=>ADC_RESULT,
         ADC_START=>ADC_START,
         ADC_PDOWN=>ADC_PDOWN,
         ADC_RESET=>ADC_RESET,
         ADC_MODE=>ADC_MODE,
         ADC_VREFSEL=>ADC_VREFSEL,
         ADC_CHNR=>ADC_CHNR,
         ADC_STC=>ADC_STC,
         ADC_DVC=>ADC_DVC,
         CM_STB=>CM_STB,
         TM_STB=>TM_STB
        );
end DEF_ARCH;
